%define fedora 19
%ifarch alpha ia64 ppc64 s390x sparc64 x86_64
%global flavor gcc64
%else
%global flavor gcc32
%endif

Name:		globus-rls-server
%global _name %(tr - _ <<< %{name})
Version:	4.9
%global setupversion 4.5
Release:	alt1_13
Summary:	Globus Toolkit - Replica Location Service Server

Group:		Networking/WWW
License:	ASL 2.0
URL:		http://www.globus.org/
#		Source is extracted from the globus toolkit installer:
#		wget -N http://www-unix.globus.org/ftppub/gt5/5.0/5.0.4/installers/src/gt5.0.4-all-source-installer.tar.bz2
#		tar -jxf gt5.0.4-all-source-installer.tar.bz2
#		mv gt5.0.4-all-source-installer/source-trees/replica/rls/server globus_rls_server-4.9
#		cp -p gt5.0.4-all-source-installer/source-trees/core/source/GLOBUS_LICENSE globus_rls_server-4.9
#		tar -zcf globus_rls_server-4.9.tar.gz globus_rls_server-4.9
Source:		%{_name}-%{version}.tar.gz
#		Source1 is extracted from the globus toolkit installer:
#		wget -N http://www-unix.globus.org/ftppub/gt5/5.0/5.0.4/installers/src/gt5.0.4-all-source-installer.tar.bz2
#		tar -jxf gt5.0.4-all-source-installer.tar.bz2
#		mv gt5.0.4-all-source-installer/source-trees/replica/rls/setup globus_rls_server_setup-4.5
#		cp -p gt5.0.4-all-source-installer/source-trees/core/source/GLOBUS_LICENSE globus_rls_server_setup-4.5
#		tar -zcf globus_rls_server_setup-4.5.tar.gz globus_rls_server_setup-4.5
Source1:	%{_name}_setup-%{setupversion}.tar.gz
#		init.d startup script
Source2:	%{name}
#		Post-install setup instructions
Source3:	%{name}.INSTALL
#		README file
Source8:	GLOBUS-RLS
#		Dereferencing of type-punned pointers:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6607
Patch0:		%{name}-type-punned-pointer.patch
#		Remove hardcoding of paths:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6595
Patch1:		%{name}-setup.patch
#		Depend on GT 5.2.0 library versions
Patch2:		%{name}-deps.patch
#		Fix RLI updates for bloomfilters (from upstream CVS)
Patch3:		%{name}-bloomfilter.patch
#		Enable new threading (from upstream CVS)
Patch4:		%{name}-pthreads.patch

Requires:	globus-rls-client%{?_isa} >= 5.2-5
Requires:	globus-common%{?_isa} >= 14
Requires:	globus-usage%{?_isa} >= 3
Requires:	globus-gss-assist%{?_isa} >= 8
Requires:	globus-io%{?_isa} >= 9
BuildRequires:	grid-packaging-tools >= 3.4
BuildRequires:	globus-core%{?_isa} >= 8
BuildRequires:	globus-rls-client-devel%{?_isa} >= 5.2-5
BuildRequires:	globus-common-devel%{?_isa} >= 14
BuildRequires:	globus-usage-devel%{?_isa} >= 3
BuildRequires:	globus-gss-assist-devel%{?_isa} >= 8
BuildRequires:	globus-io-devel%{?_isa} >= 9
BuildRequires:	libunixODBC-devel

Requires(post):		chkconfig
Requires(preun):	chkconfig
Source44: import.info

%description
The Globus Toolkit is an open source software toolkit used for building Grid
systems and applications. It is being developed by the Globus Alliance and
many others all over the world. A growing number of projects and companies are
using the Globus Toolkit to unlock the potential of grids for their cause.

The %{name} package contains:
Replica Location Service Server
Replica Location Service Server Setup

%prep
%setup -q -n %{_name}-%{version}
%setup -D -T -q -n %{_name}-%{version} -a 1
%patch0 -p1
cd %{_name}_setup-%{setupversion}
%patch1 -p1
cd -
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
# Remove files that should be replaced during bootstrap
rm -f doxygen/Doxyfile*
rm -f doxygen/Makefile.am
rm -f pkgdata/Makefile.am
rm -f globus_automake*
rm -rf autom4te.cache

# Fix hardcoded default locations
sed 's!/usr/local/etc!/etc!g' -i server.c
sed 's!/usr/local/etc!/etc!g' -i Doc/man/man8/globus-rls-server.8

unset GLOBUS_LOCATION
unset GPT_LOCATION
%{_datadir}/globus/globus-bootstrap.sh

%configure --disable-static --with-flavor=%{flavor} \
	   --with-docdir=%{_docdir}/%{name}-%{version}

# Reduce overlinking
sed 's!CC -shared !CC \${wl}--as-needed -shared !g' -i libtool

make %{?_smp_mflags}

# setup package
cd %{_name}_setup-%{setupversion}

# Remove files that should be replaced during bootstrap
rm -f doxygen/Doxyfile*
rm -f doxygen/Makefile.am
rm -f pkgdata/Makefile.am
rm -f globus_automake*
rm -rf autom4te.cache

unset GLOBUS_LOCATION
unset GPT_LOCATION
%{_datadir}/globus/globus-bootstrap.sh

%configure --without-flavor --with-docdir=%{_docdir}/%{name}-%{version}

make %{?_smp_mflags}

cd -

%install
make install DESTDIR=%{buildroot}

# setup package
cd %{_name}_setup-%{setupversion}
make install DESTDIR=%{buildroot}
cd -

# This script is intended to be sourced, not executed
chmod 644 %{buildroot}%{_datadir}/globus/setup/setup-globus-rls-server.pl

# Create setup files
mkdir -p %{buildroot}%{_sysconfdir}
sed -e s!@libdir@!%{_libdir}!g \
    -e s!@localstatedir@!%{_var}/lib/%{name}!g \
    -e s!@SQLITEODBCFLAVOR@!!g \
    -e s!@LIBSUFFIX@!so!g \
  %{buildroot}%{_datadir}/globus/setup/odbc.ini.in > \
  %{buildroot}%{_sysconfdir}/%{name}-odbc.ini
sed -e s!@ODBCINI@!%{_sysconfdir}/%{name}-odbc.ini!g \
    -e 's!^odbcini.*$!&\npidfile\t\t\t/var/run/%{name}.pid!g' \
  %{buildroot}%{_datadir}/globus/setup/%{name}.conf.in > \
  %{buildroot}%{_sysconfdir}/%{name}.conf
chmod 600 %{buildroot}%{_sysconfdir}/%{name}.conf
sed s!@sbindir@!%{_sbindir}!g \
  %{buildroot}%{_datadir}/globus/setup/rls-ldif.conf.in > \
  %{buildroot}%{_sysconfdir}/rls-ldif.conf

GLOBUSPACKAGEDIR=%{buildroot}%{_datadir}/globus/packages

# Remove the SXXrls.in file
rm %{buildroot}%{_datadir}/globus/setup/SXXrls.in
sed /SXXrls.in/d -i $GLOBUSPACKAGEDIR/%{_name}_setup/noflavor_data.filelist
sed -e 's/"SXXrls", //' -e '/SXXrls/d' \
  -i %{buildroot}%{_datadir}/globus/setup/setup-globus-rls-server.pl

# Fix man page section
sed 's!^\(\.TH.*\) 1 !\1 8 !' \
  %{buildroot}%{_mandir}/man1/globus-rls-reporter.1 > \
  %{buildroot}%{_mandir}/man8/globus-rls-reporter.8
rm %{buildroot}%{_mandir}/man1/globus-rls-reporter.1
sed 's!/man1/\(.*\)\.1!/man8/\1.8!' \
  -i $GLOBUSPACKAGEDIR/%{_name}/noflavor_doc.filelist

# Install start-up script
mkdir -p %{buildroot}%{_initrddir}
install -p %{SOURCE2} %{buildroot}%{_initrddir}/%{name}

# Install license file
mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}
install -m 644 -p GLOBUS_LICENSE %{buildroot}%{_docdir}/%{name}-%{version}

# Install README file
install -m 644 -p %{SOURCE8} %{buildroot}%{_docdir}/%{name}-%{version}/README

# Install post installation instructions
install -m 644 -p %{SOURCE3} \
  %{buildroot}%{_docdir}/%{name}-%{version}/README.Fedora

# Adapt to different versions of the mysql connector
%if %{?fedora}%{!?fedora:0} <= 4 && %{?rhel}%{!?rhel:0} <= 4
sed s/mysql-connector-odbc/MyODBC/ \
  -i %{buildroot}%{_docdir}/%{name}-%{version}/README.Fedora
sed s/libmyodbc3_r/libmyodbc/ \
  -i %{buildroot}%{_sysconfdir}/%{name}-odbc.ini \
     %{buildroot}%{_datadir}/globus/setup/odbc.ini.in
%endif
%if %{?fedora}%{!?fedora:0} >= 13 || %{?rhel}%{!?rhel:0} >= 6
sed s/libmyodbc3_r/libmyodbc5/ \
  -i %{buildroot}%{_sysconfdir}/%{name}-odbc.ini \
     %{buildroot}%{_datadir}/globus/setup/odbc.ini.in
%endif

# Remove pkg-config files...
rm %{buildroot}%{_libdir}/pkgconfig/*.pc
rm $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist
rm $GLOBUSPACKAGEDIR/%{_name}/pkg_data_%{flavor}_dev.gpt
rm $GLOBUSPACKAGEDIR/%{_name}_setup/noflavor_dev.filelist
rm $GLOBUSPACKAGEDIR/%{_name}_setup/pkg_data_noflavor_dev.gpt

# Generate package filelists
cat $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_pgm.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/noflavor_data.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/noflavor_doc.filelist \
    $GLOBUSPACKAGEDIR/%{_name}_setup/noflavor_pgm.filelist \
    $GLOBUSPACKAGEDIR/%{_name}_setup/noflavor_data.filelist \
  | sed -e s!^!%{_prefix}! -e 's!^.*/man/.*!%doc &*!' \
	-e 's!%{_prefix}%{_sysconfdir}!%config(noreplace) %{_sysconfdir}!' \
  > package.filelist

mkdir -p $RPM_BUILD_ROOT`dirname /etc/sysconfig/globus-rls-server`
touch $RPM_BUILD_ROOT/etc/sysconfig/globus-rls-server

%post
if [ $1 -eq 1 ]; then
  /sbin/chkconfig --add %{name}
fi

%preun
if [ $1 -eq 0 ]; then
  /sbin/service %{name} stop >/dev/null 2>&1 || :
  /sbin/chkconfig --del %{name}
fi

%postun
if [ $1 -ge 1 ]; then
  /sbin/service %{name} condrestart >/dev/null 2>&1 || :
fi

%files -f package.filelist
%dir %{_datadir}/globus/packages/%{_name}
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/GLOBUS_LICENSE
%doc %{_docdir}/%{name}-%{version}/README
%dir %{_datadir}/globus/packages/%{_name}_setup
%dir %{_datadir}/globus/aggrexec
%dir %{_datadir}/globus/setup
%config(noreplace) %{_sysconfdir}/%{name}-odbc.ini
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/rls-ldif.conf
%{_initrddir}/%{name}
%doc %{_docdir}/%{name}-%{version}/README.Fedora
# hack; explicitly added docdir if not owned
%doc %dir %{_docdir}/%{name}-%{version}
%config(noreplace,missingok) /etc/sysconfig/globus-rls-server

%changelog
* Mon Mar 11 2013 Igor Vlasenko <viy@altlinux.ru> 4.9-alt1_13
- update to new release by fcimport

* Tue Jan 29 2013 Igor Vlasenko <viy@altlinux.ru> 4.9-alt1_12
- update to new release by fcimport

* Sun Jan 13 2013 Igor Vlasenko <viy@altlinux.ru> 4.9-alt1_11
- initial fc import

